use std::sync::Arc;

use super::*;

pub struct State<T: 'static + Default + Send + Sync>(pub Arc<T>);

impl<T: 'static + Default + Send + Sync> System for State<T> {
    const DEPENDENCIES: Dependencies = &[];

    const EVENT_HANDLERS: EventHandlers = &[];

    fn new(_: ContextHandle) -> Self {
        Self(Arc::new(T::default()))
    }

    fn start(&mut self) {
    }
}